#include <syidef.h>
#include <stdlib.h>
#include <starlet.h>
#include <iccdef.h>
#include <iledef.h>
#include <stdio.h>
#include <descrip.h>
#include <lib$routines.h>
#include <iosbdef.h>
#include <string.h>
#include <ssdef.h>
#include <stsdef.h>
#define check(STS) if(!$VMS_STATUS_SUCCESS(STS)) sys$exit(STS)
#define MAX_BUFF 1000
/* Prototype for the REQUIRED connection ast routine. */
void        conn_ast (unsigned int event_type, unsigned int c_handle,
		      unsigned int data_len, char *data_buff,
		      unsigned int p5,
		      unsigned int p6,
		      char *p7);

/* Static storage is used to pass connection handle back to main.
 * This is a little unstructured, but there is little alternative in this
 * simple design. */
static int  Handle;
static unsigned int Efn;

int main (void) {
  int         status;
  int         a_handle;

  $DESCRIPTOR (a_name, "VERY_SIMPLE_SERVER");
  int         acc_len;
  char        u_data[] = "Fan mail from a flounder.";
  struct _ios_icc icc_iosb;
  char        buffer[BUFSIZ];
  int         i;
  int	      len;

  memset(buffer, ' ', MAX_BUFF - 1);
  buffer[MAX_BUFF - 1] = '\0';

  status = lib$get_ef(&Efn);
  check(status);
  status = sys$clref(Efn);
  check(status);

  /* Establish an association for VERY_SIMPLE_SERVER.
   * NOTE: the connection AST is not optional for a server.
   */
  printf ("Setting up association\n");
  status = sys$icc_open_assoc (&a_handle, &a_name, 0, 0, conn_ast,
			       0, 0, 0, 0);
  check (status);

  /* Go to sleep until somebodey wants to "hear" what we have to say. */
  printf ("Waiting to accept connect request.\n");
  status = sys$waitfr(Efn);
  check(status);

  /* Accept the client's connection request. Send along a little message
   * that she/he can read after completing the connect request.
   * Handle passed to us through the connection AST routine.
   */
  status = sys$icc_accept (Handle, u_data, sizeof (u_data), 0, 0);
  check (status);

  /* NOTE: due to the very simple design, we will read in one more
   * user message than the client will accept!
   */
  len = strlen(buffer) + 1;
  status = lib$init_timer(0);
  check (status);

  do {
    status = sys$icc_transmitw(Handle, &icc_iosb, 0, 0, buffer, len);
    if(status != SS$_WRONGSTATE) {
      if (! $VMS_STATUS_SUCCESS(status)) {
        status = lib$show_timer(0, 0, 0, 0);
        check (status);
      }
      check (status);
      if (! $VMS_STATUS_SUCCESS(icc_iosb.ios_icc$w_status)) {
        status = lib$show_timer(0, 0, 0, 0);
        check (status);
      }
      check (icc_iosb.ios_icc$w_status);
    } else {
      printf ("Last item (%s) was not transmitted.\n", buffer);
    }
  } while (status != SS$_WRONGSTATE);

  status = lib$show_timer(0, 0, 0, 0);
  check (status);
  return (EXIT_SUCCESS);
}


/* Connection AST routine. */
#define MAX_UNAME 12
void 
conn_ast (unsigned int event_type, unsigned int c_handle,
	  unsigned int data_len, char *data_buff,
	  unsigned int p5,
	  unsigned int p6,
	  char *p7)
{
  char        user[MAX_UNAME + sizeof ('\0')];
  static int  conn_count = 0;
  int         status;
  char        rej_buf[] = "I'm too busy too deal with you now!";

  /* Get and print the connecting user name.  Note: you must copy this info
   * prior to calling any othert ICC system services.
   */
  strncpy (user, p7, MAX_UNAME);
  user[MAX_UNAME] = '\0';


  /* Guarantee only one connection is accepted by this process. */
  if (conn_count == 0) {
    printf ("Accepting connection for user: %s\n", user);
    /* Display connecting process' pid. */
    printf ("With pid: %8x\n", p6);
  } else {
    /* Ignore any after first connection. */
    printf ("Rejecting connection for user: %s\n", user);
    /* Display connecting process' pid. */
    printf ("With pid: %8x\n", p6);
    status = sys$icc_reject (c_handle, rej_buf, sizeof (rej_buf),
			     0);
    check (status);
    return;
  }
  conn_count++;
  printf ("Accepting connection for user: %s\n", user);
  /* Display connecting process' pid. */
  printf ("With pid: %8x\n", p6);
  /* Pass the connection handle back to main. */
  Handle = c_handle;

  /* wake up and get to work. */
  status = sys$setef(Efn);
  check(status);
}
